<template>
  <div class="w-full">
    <div class="flex w-full items-center py-2">
      <span class="font-bold text-lg dark:text-white">
        Dependencies
      </span>

      <app-button
        class="ml-auto w-20 md:w-auto dark:text-white"
        type="button"
        @click="showModal = true"
      >
        add dependencies
      </app-button>
    </div>
    <div class="border-t border-gray-400">
      <div
        v-if="!selectedItems.length"
        class="italic py-4 dark:text-white"
      >
        No dependency selected
      </div>
      <ul
        v-else
        class="overflow-auto flex-grow-1 relative"
      >
        <li
          v-for="(item, index) in selectedItems"
          :key="`item-${index}`"
          :class="{
            'border-b relative dark:border-gray-400 bg-transparent py-4 pr-12 dark:text-white group': true,
            'sticky top-0': item.isGroupTitle,
          }"
        >
          <strong>
            {{ item.name }}
          </strong>
          <span class="bg-primary text-white dark:text-gray-800 font-bold text-lg inline-block px-2 pr-3 ml-2">
            {{ item.tag }}
          </span>
          <p>
            {{ item.description }}
          </p>
          <span
            class="
              absolute top-4 duration-150 font-bold cursor-pointer block h-6 w-6 right-4 text-center leading-5 rounded-full bg-red-500 text-white opacity-0
              group-hover:opacity-100
            "
            @click="removeDependency(item)"
            v-text="'-'"
          />
        </li> 
      </ul>
    </div>
  </div>
  <div
    :class="{
      'fixed left-0 w-screen h-screen bg-gray-900 bg-opacity-70 z-10': true,
      '-top-full': !showModal,
      'top-0': showModal,
    }"
  >
    <div
      class="w-screen h-screen absolute"
      @click="showModal = false"
    />
    <div
      class="
        bg-white flex flex-col h-screen relative max-h-screen
        md:w-3/5 md:mx-auto md:mt-5 md:h-5/6
        dark:bg-gray-800
      "
    >
      <div class="flex-shrink-0 h-16 border-b border-gray-400 relative">
        <input
          v-model="searchWord"
          class="h-16 w-full bg-transparent focus:outline-none px-4 dark:text-white"
          placeholder="Web, Security, JPA, Actuator, Devtools..."
          type="text"
        >
        <button
          class="
            w-10 h-10 absolute right-0 top-6 transform rotate-45 -translate-y-2/4 text-5xl focus:outline-none
            dark:text-white dark
             cursor-pointer 
          "
          @click="showModal = false"
        >
          <span>
            +
          </span>
        </button>
      </div>
      <ul class="overflow-auto flex-grow-1 relative">
        <template
          v-for="(item, index) in notSelectedDescriptions"
          :key="`item-${index}`"
        >
          <li
            v-if="item.isGroupTitle && !(notSelectedDescriptions[index + 1].isGroupTitle)"
            :class="{
              'border-b dark:border-gray-600 bg-white dark:bg-gray-800 dark:text-white p-4': true,
              'sticky top-0': item.isGroupTitle,
              'cursor-pointer hover:bg-primary': !item.isGroupTitle,
            }"
          >
            <span
              class="bg-primary text-white font-bold text-lg inline-block px-2 pr-3"
            >
              {{ item.name }}
            </span>
          </li>
          <li
            v-if="!item.isGroupTitle"
            tabindex="0"
            :class="{
              'border-b dark:border-gray-600 bg-white dark:bg-gray-800 dark:text-white p-4': true,
              'sticky top-0': item.isGroupTitle,
              'cursor-pointer hover:bg-primary hover:text-white focus:bg-primary focus:text-white': !item.isGroupTitle,
            }"
            @keydown.enter="clickHandler($event, item)"
            @click="clickHandler($event, item)"
          >
            <strong>
              {{ item.name }}
            </strong>
            <span
              v-if="searchWord"
              class="bg-primary text-white dark:text-gray-800 font-bold text-lg inline-block px-2 pr-3 ml-2"
            >
              {{ item.tag }}
            </span>
            <p>
              {{ item.description }}
            </p>
          </li>
        </template>
      </ul>
    </div>
  </div>
</template>

<script>
const dependencies = require('@/assets/dependencies.json');

export default {
  props: {
    selectedItems: {
      type: Array,
      default: () => []
    }
  },
  emits: ['update:selectedItems'],
  data() {
    return {
      showModal: false,
      descriptions: Object.freeze(dependencies),
      searchWord: ''
    }
  },
  computed: {
    descriptionsFlat () {
      return this.descriptions.values.reduce((acc, item) => {
        const values = item.values.map((value) => {
          return {...value, tag: item.name}
        })
        acc.push({ name: item.name, isGroupTitle: true }, ...values)
        return acc
      }, [])
    },

    notSelectedDescriptions () {
      let descriptions = [];
      const notSelected = this.descriptionsFlat.filter((item) => {
        const isSelected = this.selectedItems.some(selected => {
          return selected.name === item.name
        })
        if (isSelected) {
          return false
        } else {
          return item
        }
      })
      if (this.searchWord) {
        descriptions = notSelected.filter((searching) => {
          if (searching.isGroupTitle) return false
          return searching.name.toLowerCase().includes(this.searchWord.toLowerCase())
        })
      } else {
        descriptions = notSelected
      }
      return descriptions
    },
  },
  methods: {
    openModal() {
      this.$vfm.show('dependencies-collector')
    },
    removeDependency(item) {
      const removeIndex = this.selectedItems.indexOf(item)
      const toReturn = [...this.selectedItems]

      toReturn.splice(removeIndex, 1)
      this.$emit('update:selectedItems', toReturn)
    },
    async clickHandler(event, item) {
      this.$emit('update:selectedItems', [...this.selectedItems, item])
      if (!event.ctrlKey) {
        this.showModal = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>

</style>